<template>
  <div class="container">
    <main>
      <h2>{{ name }}</h2>
      <ul>
        <StatesComponent
          class="state"
          v-for="state in level.states"
          :key="state.view.id"
          :state="state"
          v-on:click="onClick(state)"
          @remove="onRemove"
          @update="onUpdate"
        />
      </ul>
    </main>
    <aside>
      <SidebarComponent
        :open="sidebarOpen"
        :state="stateSelected"
        @close="onClose"
      />
    </aside>
  </div>
</template>

<script>
import { computed, ref } from "vue";
import { useLevelStore } from "@/stores/level";
import { useUiStore } from "@/stores/ui";
import StatesComponent from "@/components/StatesComponent";
import SidebarComponent from "@/components/SidebarComponent";

import dummyData from "@/assets/example_level_1.json"; // dummy fetch level API

export default {
  name: "FlowEditor",
  components: {
    StatesComponent,
    SidebarComponent
  },
  setup() {
    const ui = useUiStore();
    const level = useLevelStore();
    const stateSelected = ref({});
    const onRemove = stateID => level.remove(stateID);
    const onUpdate = state => level.update(state);
    const onClick = state => {
      ui.openSidebar();
      stateSelected.value = state; // TODO binding not working
      console.log(state);
    };
    const onClose = () => ui.closeSidebar();
    return {
      sidebarOpen: computed(() => ui.sidebarOpen),
      stateSelected,
      level,
      name: computed(() => level.name),
      onRemove,
      onUpdate,
      onClick,
      onClose
    };
  },
  async mounted() {
    const result = await dummyData; // dummy fetch level API
    this.level.init(result);
  }
};
</script>

<style scoped>
.container {
  display: flex;
}

aside {
  flex: 1;
}

main {
  flex: 2;
  margin-right: 1rem;
}
</style>
